<?php
require_once 'connect.php';
//header('Access-Control-Allow-Origin: *');

$nr_mes = 7;
$nr_ano = 2018;

if(isset($_POST['nr_mes'])){
    $nr_mes     = $_POST['nr_mes'];
}
if(isset($_POST['nr_ano'])){
    $nr_ano     = $_POST['nr_ano'];
}

if(isset($_POST['metas_list'])){
    $ar_metas_ano = array();
    $sql    =   "select * from erpc_financeiro_metas where YEAR(dt_meta) = $nr_ano";
    
    $resultado  =   mysqli_query($conexao, $sql) or die(mysqli_error($conexao));
    if(mysqli_num_rows($resultado) > 0){
        while($registro = mysqli_fetch_assoc($resulto)){
            $ar_meta_mes = array(
                'vl_meta_receita' =>  $registro['vl_meta_receita'],
                'vl_meta_despesa' =>  $registro['vl_meta_despesa'],
                'vl_meta_lucro'   =>  $registro['vl_meta_lucro_prejuizo'],
                'vl_meta_lucratividade' => $registro['vl_meta_lucratividade']                
            );
            array_push($ar_metas_ano, $ar_meta_mes);
        }
    }
    echo json_encode($ar_metas_ano);
}else{
    
    $ar_retorno = array(
        'vl_receita' => '',
        'vl_receita_impressao' => 'R$ 0,00',
        'vl_receita_meta' => '',
        'pr_receita_realizadoxmeta' => 'Realizado x Meta = 0%',
        'vl_despesa' => '',
        'vl_despesa_impressao' => 'R$ 0,00',
        'vl_despesa_meta' => '',
        'pr_despesa_realizadoxmeta' => 'Realizado x Meta = 0%',
        'vl_lucro_prejuizo' => '',
        'vl_lucro_prejuizo_impressao' => 'R$ 0,00',
        'vl_lucro_prejuizo_meta' => '',
        'pr_lucro_realizadoxmeta' => 'Realizado x Meta = 0%',
        'pr_lucratividade' => '0',
        'vl_lucratividade_meta' => '',
        'pr_lucratividade_realizadoxmeta' => 'Realizado x Meta = 0%',
        'receitas' =>   array(),
        'despesas' =>   array()
    ); 
    
    
    $vl_receita = 0;
    $vl_despesa = 0;
    
    //Obtenção dos valores de Receita e Despesa
    $sql_receitas_despesas = "select   id_tipo_titulo
                            		,sum(vl_saldo-vl_desconto) as saldo
                            from erpc_financeiro_lancamentos
                            where 	 year(dt_vencimento) = $nr_ano
                            		and month(dt_vencimento) = $nr_mes
                            	group by id_tipo_titulo;";
    
    $resultado_receitas_despesas = mysqli_query($conexao, $sql_receitas_despesas);
    if(mysqli_num_rows($resultado_receitas_despesas)>0){
        while($registro = mysqli_fetch_assoc($resultado_receitas_despesas)){
            if($registro['id_tipo_titulo'] == 1){
                $vl_receita = $registro['saldo'];
                $ar_retorno['vl_receita'] = $vl_receita;
                $ar_retorno['vl_receita_impressao'] = 'R$ ' . number_format($vl_receita, 2, ',', '.');
            }else{
                $vl_despesa = $registro['saldo'];
                $ar_retorno['vl_despesa'] = $vl_despesa;
                $ar_retorno['vl_despesa_impressao'] = 'R$ ' . number_format($vl_despesa, 2, ',', '.');
            }
        }
    }
    
    
    //Obtenção dos valores das Metas
    /*
    $sql_metas = "select	 if(tp_meta = 1, 'receita', if(tp_meta = 2, 'despesa', if(tp_meta = 3, 'lucro', 'lucratividade'))) tp_meta
                    		,vl_meta
                    from erpc_financeiro_metas
                    	where 	year(dt_meta) = $nr_ano
                    			and month(dt_meta) = $nr_mes;";
    $resultado_metas = mysqli_query($conexao, $sql_metas);
    if(mysqli_num_rows($resultado_metas) > 0){
        $i = 0;
        while($registro = mysqli_fetch_assoc($resultado_metas)){
            if($registro['tp_meta'] == 'receita'){
                $ar_retorno['vl_receita_meta'] = $registro['vl_meta'];
            }elseif($registro['tp_meta'] == 'despesa'){
                $ar_retorno['vl_despesa_meta'] = $registro['vl_meta'];
            }elseif($registro['tp_meta'] == 'lucro'){
                $ar_retorno['vl_lucro_prejuizo_meta'] = $registro['vl_meta'];
            }else{
                $ar_retorno['vl_lucratividade_meta'] = $registro['vl_meta'];
            }
        }
    }
    */
    
    $sql    =   "select * from erpc_financeiro_metas where YEAR(dt_meta) = $nr_ano and MONTH(dt_meta) = $nr_mes;";
    
    $resultado  =   mysqli_query($conexao, $sql) or die(mysqli_error($conexao));
    if(mysqli_num_rows($resultado) > 0){
        while($registro = mysqli_fetch_assoc($resultado)){
            $ar_retorno['vl_receita_meta'] = $registro['vl_meta_receita'];
            $ar_retorno['vl_despesa_meta'] = $registro['vl_meta_despesa'];
            $ar_retorno['vl_lucro_prejuizo_meta']   = $registro['vl_meta_lucro_prejuizo'];
            $ar_retorno['vl_lucratividade_meta']    = $registro['vl_meta_lucratividade'];
        }
    }
    
    
    //Cálculo de Lucro/Prejuízo e da Lucratividade
    $vl_lucro_prejuizo = $vl_receita - $vl_despesa;
    $pr_lucratividade = 0;
    
    if($vl_receita != 0){
        $pr_lucratividade = ($vl_lucro_prejuizo/$vl_receita)*100;
    }
    
    
    $ar_retorno['vl_lucro_prejuizo'] = $vl_lucro_prejuizo;
    $ar_retorno['vl_lucro_prejuizo_impressao'] = 'R$ ' . number_format($vl_lucro_prejuizo, 2, ',', '.');
    $ar_retorno['pr_lucratividade'] = round($pr_lucratividade,2);
    
    //Cálculo dos Realizados x Metas
    if($ar_retorno['vl_receita_meta'] != ''){
        $pr_receita_realizado_meta = ($vl_receita*100)/$ar_retorno['vl_receita_meta'];
        $ar_retorno['pr_receita_realizadoxmeta'] = 'Realizado x Meta = ' . str_replace('.',',',round($pr_receita_realizado_meta,2)) . '%';
    }
    if($ar_retorno['vl_despesa_meta'] != ''){
        $pr_despesa_realizado_meta = ($vl_despesa*100)/$ar_retorno['vl_despesa_meta'];
        $ar_retorno['pr_despesa_realizadoxmeta'] = 'Realizado x Meta = ' . str_replace('.',',',round($pr_despesa_realizado_meta,2)) . '%';
    }
    if($ar_retorno['vl_lucro_prejuizo_meta'] != ''){
        $pr_lucro_realizado_meta = ($vl_lucro_prejuizo*100)/$ar_retorno['vl_lucro_prejuizo_meta'];
        $ar_retorno['pr_lucro_realizadoxmeta'] = 'Realizado x Meta = ' . str_replace('.',',',round($pr_lucro_realizado_meta, 2)) . '%';
    }
    if($ar_retorno['vl_lucratividade_meta'] != ''){
        $pr_lucratividade_realizado_meta = ($pr_lucratividade*100)/$ar_retorno['vl_lucratividade_meta'];
        $ar_retorno['pr_lucratividade_realizadoxmeta'] = 'Realizado x Meta = '. str_replace('.',',',round($pr_lucratividade_realizado_meta, 2)) . '%';
    }
    
    //Divisão das Receitas e Despesas por Plano de Contas
    
    $sql_lancamentos    =   "select  if(id_tipo_titulo=1, 'receita', 'despesa') tp_titulo
                                    ,pc.ds_codigo cod_plano
                                    ,pc.ds_plano
                                    ,sum(vl_saldo - vl_desconto) saldo
                                from 	erpc_financeiro_lancamentos lanc
                                    inner join erpc_financeiro_plano_contas pc
                                        on lanc.id_planofin = pc.id
                                where year(lanc.dt_vencimento) = $nr_ano
                                      and month(lanc.dt_vencimento) = $nr_mes  
                                group by id_planofin
                                order by cod_plano"; 
    
    $resultado_lancamentos = mysqli_query($conexao, $sql_lancamentos);
    
    $temp_ar_receitas = array();
    $temp_ar_despesas = array();
    
    if(mysqli_num_rows($resultado_lancamentos) > 0){
        while($registro = mysqli_fetch_assoc($resultado_lancamentos)){
            $ds_plano = $registro['ds_plano'];
            $vl_saldo = $registro['saldo'];
            if($registro['tp_titulo'] == 'receita'){
                array_push($temp_ar_receitas, array('receita' => $ds_plano, 'vl_receita' => $vl_saldo));
            }else{
                array_push($temp_ar_despesas, array('despesa' => $ds_plano, 'vl_despesa' => $vl_saldo));
            }
        }
    }
    
    $ar_retorno['receitas'] = $temp_ar_receitas;
    $ar_retorno['despesas'] = $temp_ar_despesas;
    
    
    echo json_encode($ar_retorno);
}

?>